// support code for Eeek!  XML!  Over at MacEdition
// http://macedition.com/bolts/bolts_20030610.php

// this code is in the public domain.  have fun.

#import <Foundation/Foundation.h>
#import "display.h"


// load some XML into memory using Apple's High-level XML API.

void loadStuff ()
{
    NSString *location;

    // pick a location.  You'll need to dig up an XML file from
    // somewhere and then use the path to the file, or else
    // use an http:// url to an XML page someone has on the net
    location = @"file:///Users/markd/Development/misc/xml/highlevel/test.xml";
    location = @"http://badgertronics.com/blog/blog-xml";

    CFURLRef sourceURL;
    sourceURL = 
	CFURLCreateWithString (NULL, // allocator
			       (CFStringRef)location,  // url string
			       NULL); // absolute url;

    if (sourceURL == NULL) {
	NSLog (@"could not load location '%@'.", location);
	NSLog (@"You may need to specify a different path to the file");
	exit (0);
    }


    // load xml data using the URL
    CFDataRef		xmlData;
    BOOL 		result;
    SInt32 		errorCode;
    NSDictionary       *dictionary;

    result = CFURLCreateDataAndPropertiesFromResource 
	(kCFAllocatorDefault,
	 sourceURL, &xmlData,
	 (CFDictionaryRef*)&dictionary,
	 NULL, &errorCode);

    if (!result) {
	printf ("could not create data/properties.  Error code is %d\n",
		(int)errorCode);
	exit (0);
    }

    CFXMLTreeRef	cfXMLTree;
    cfXMLTree = CFXMLTreeCreateFromData (kCFAllocatorDefault,
					 xmlData,
					 NULL,
					 kCFXMLParserSkipWhitespace 
					 | kCFXMLParserReplacePhysicalEntities,
					 kCFXMLNodeCurrentVersion);

    // walk the tree and display it.
    dumpTree (cfXMLTree, 0);

} // loadStuff



int main (int argc, const char *argv[]) 
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    loadStuff ();

    [pool release];

    return (0);

} // main
